#! /usr/bin/python -t
## --*- python -*--
import sys
import antlr
import lexcalc



### create my lexer - read from stdin
Lexer = lexcalc.Lexer()

try:
   token = Lexer.nextToken()
   while not token.isEOF():
      ### Is there a way to simplify this loop??
      ### this looks complicated to me. However, we can't simply
      ### return none to check  for EOF as we would like to know
      ### where  EOF appeared  (file, line, col etc). This would
      ### be lost. Or we could return NIL in case of EOF and, if
      ### we are really want to know more about EOF ask lexer to
      ### provide this information. But this would extend the
      ### lexer's interface. Another idea would be to return EOF
      ### by  exception, but EOF is actually not an exception at
      ### all.
      ### handle token
      print token
      token = Lexer.nextToken()
      
except antlr.TokenStreamException, e:
   print "error: exception caught while lexing: "
      
