import java.io.DataInputStream;
import java.io.Reader;
import java.io.InputStream;

import antlr.CharBuffer;
import antlr.InputBuffer;
import antlr.LexerSharedInputState;
import antlr.ByteBuffer;
import antlr.Token;

import antlr.TokenStreamException;
import antlr.NoViableAltForCharException;
import antlr.MismatchedCharException;
import antlr.CharStreamException;

class lexer0 extends antlr.CharScanner {

  public boolean altcomment = true ;

  public boolean state_with_syntax = false;

  /* Note: do not provide other constructors here - the subclass
   * constructors are doing specialized initialization which can
   * not be done at this level (table of literals for example).
   */
  
  public lexer0(LexerSharedInputState state) {
    super(state);
  }

  public Token nextToken() throws TokenStreamException {
    /* shall never be called - required to shutup abstract
     * method defined in antlr.TokenStream 
     */
    return null;
  }

  /** check whether a string contains a lower case char */
  protected int haslowerchar(String s) {
    String y = s.toUpperCase();
    return y.equals(s) ? 0 : 1;
  }

  protected String chr_ws_erase(String s,String eol,String ws)
  {
    /* shall remove (ws)* eol (ws)* from s - ie. remove any ws
    ** chars before and after any newline (eol) character
    */
    return s;
  }

  public boolean eofnotseen = true;
  
  public void uponEOF() {
    eofnotseen = false;
  }
  
  protected void throw_no_viable_alt_for_char(char c) throws
    NoViableAltForCharException
  {
    throw new NoViableAltForCharException(
      c, 
      getFilename(), 
      getLine(), 
      getColumn()
      );
  }

  protected void handle_comment() throws
    NoViableAltForCharException,
    MismatchedCharException,
    CharStreamException
    
  {
    switch ( LA(1)) {
      case '-':
      {
        match("--");
        break;
      }
      case '\n':
      {
        match('\n');
        newline();
        break;
      }
      case '\r': 
      {
        match('\r');
        if(LA(2)=='\n') {
          match('\n');
        }
        newline();
        break;
      }
      case '\u000b' :
      {
        match('\u000b');
        newline();
        break;
      }
      case '\u000c':
      {
        match('\u000c');
        newline();
        break;
      }
      default:
        throw_no_viable_alt_for_char((char)LA(1));
    }
  }
}
